- hosts: all
  become: true
  vars:
    #create_containers: 4
    web_proxy_container_name: web
    web_proxy_container_image: nginx
    
    web_api_container_name: api
    web_api_container_image: tomcat:9-jdk8

    web_ui_container_name: ui
    web_ui_container_image: tomcat:9-jdk8
    Fruits:
      Apple: 'Red'
      Orange: 'Orange'
      Grapes: 'Greem'

    #default_container_command: sleep 1d

  tasks:
    - name: Install aptitude using apt
      apt: name=aptitude state=latest update_cache=yes force_apt_get=yes

    - name: Install required system packages
      apt: 
        name: ['apt-transport-https', 'ca-certificates', 'curl', 'software-properties-common', 'python3-pip', 'virtualenv','python3-setuptools']
        #name: "{{ item }}"
        state: latest 
        update_cache: yes
    
      #with_items:
           #- apt-transport-https
           #- ca-certificates
           #- curl
           #- software-properties-common
           #- python3-pip
           #- virtualenv 
           #- python3-setuptools

    - name: Add Docker GPG apt Key
      apt_key:
        url: https://download.docker.com/linux/ubuntu/gpg
        state: present

    - name: Add Docker Repository
      apt_repository:
        repo: deb https://download.docker.com/linux/ubuntu bionic stable
        state: present

    - name: Update apt and install docker-ce
      apt: 
        update_cache: yes 
        name: docker-ce 
        state: latest

    - name: Install Docker Module for Python
      pip:
        name: docker


    - name: Pull Docker image
      docker_image:
        name: "{{ item }}"
        source: pull
      loop:
        - "{{ web_proxy_container_image }}"
        - "{{web_ui_container_image}}"

 # Creates the number of containers defined by the variable create_containers, using default values
    - name: Create web proxy containers
      docker_container:
        name: "{{ web_proxy_container_name }}"
        image: "{{ web_proxy_container_image }}"
        ports:
         - "80:80"
        #command: "{{ default_container_command }}"
        state: started

    - name: Create ui containers
      docker_container:
        name: "{{ web_ui_container_name }}"
        image: "{{ web_ui_container_image }}"
        ports:
         - "8080:8080"
        #command: "{{ default_container_command }}"
        state: started
      


    - name: Create api containers
      docker_container:
        name: "{{ web_api_container_name }}"
        image: "{{ web_api_container_image }}"
        ports:
         - "8181:8181"
        #command: "{{ default_container_command }}"
        state: started
     


    - name: item.0 returns from the 'a' list, item.1 returns from the '1' list
      debug:
        msg: "{{ item.0 }} and {{ item.1 }}"
      with_together:
        - ['a', 'b', 'c', 'd']
        - [1, 2, 3, 4]    
      tags:
        - test
        
    - name: unlike with_items you will get 3 items from this loop, the 2nd one being a list
      debug: 
         msg: "{{ item }}"
      with_list:
       - 1
       - [2,3]
       - 4
      tags:
        - test
    - name: Ansible loop with index example
      debug:
        msg: "echo loop index at {{ item.0 }} and value at {{item.1}}"
      with_indexed_items:
        - "hello1"
        - "hello2"
        - "hello3"
      tags:
        - test

    - name: Ansible dictionary loop Example
      debug:
        msg: "Key is {{ item.key}} and color is {{item.value}}"
      with_dict: "{{ Fruits }}"    
      tags:
        - test
   # Pull image specified by variable default_image from the Docker Hub
    #- name: Pull Docker image
    #  docker_image:
    #    name: ["{{ web_proxy_container_image }}","{{web_ui_container_image}}"]
    #    source: pull

